/**
 * This file was auto-generated by @ui/openapi.
 * Do not make direct changes to the file.
 */

export const actions = [
    'stress-cpu',
    'stress-mem',
    'disk-read-payload',
    'disk-write-payload',
    'disk-fill',
    'network-corrupt',
    'network-duplicate',
    'network-loss',
    'network-delay',
    'network-partition',
    'network-dns',
    'network-bandwidth',
    'network-flood',
    'network-down',
    'process',
    'jvm-exception',
    'jvm-gc',
    'jvm-latency',
    'jvm-return',
    'jvm-stress',
    'jvm-rule-data',
    'jvm-mysql',
    'clock',
    'redis-expiration',
    'redis-penetration',
    'redis-cacheLimit',
    'redis-restart',
    'redis-stop',
    'kafka-fill',
    'kafka-flood',
    'kafka-io',
    'file-create',
    'file-modify',
    'file-delete',
    'file-rename',
    'file-append',
    'file-replace',
    'vm',
    'user_defined',
  ],
  data = [
    {
      field: 'label',
      label: 'address',
      value: [],
      helperText: 'Optional. DEPRECATED: Use Selector instead. Only one of Address and Selector could be specified.',
    },
    {
      field: 'ref',
      label: 'clock',
      children: [
        {
          field: 'text',
          label: 'clock-ids-slice',
          value: '',
          helperText:
            'the identifier of the particular clock on which to act. More clock description in linux kernel can be found in man page of clock_getres, clock_gettime, clock_settime. Muti clock ids should be split with ","',
        },
        {
          field: 'number',
          label: 'pid',
          value: 0,
          helperText: 'the pid of target program.',
        },
        {
          field: 'text',
          label: 'time-offset',
          value: '',
          helperText: 'specifies the length of time offset.',
        },
      ],
      when: "action=='clock'",
    },
    {
      field: 'ref',
      label: 'disk-fill',
      children: [
        {
          field: 'select',
          label: 'fill-by-fallocate',
          value: false,
          items: [true, false],
          helperText: 'fill disk by fallocate',
        },
        {
          field: 'text',
          label: 'path',
          value: '',
          helperText:
            'specifies the location to fill data in. if path not provided, payload will read/write from/into a temp file, temp file will be deleted after writing',
        },
        {
          field: 'text',
          label: 'size',
          value: '',
          helperText:
            'specifies how many units of data will write into the file path. support unit: c=1, w=2, b=512, kB=1000, K=1024, MB=1000*1000, M=1024*1024, GB=1000*1000*1000, G=1024*1024*1024 BYTES. example : 1M | 512kB',
        },
      ],
      when: "action=='disk-fill'",
    },
    {
      field: 'ref',
      label: 'disk-read-payload',
      children: [
        {
          field: 'text',
          label: 'path',
          value: '',
          helperText:
            'specifies the location to fill data in. if path not provided, payload will read/write from/into a temp file, temp file will be deleted after writing',
        },
        {
          field: 'number',
          label: 'payload-process-num',
          value: 0,
          helperText: 'specifies the number of process work on writing, default 1, only 1-255 is valid value',
        },
        {
          field: 'text',
          label: 'size',
          value: '',
          helperText:
            'specifies how many units of data will write into the file path. support unit: c=1, w=2, b=512, kB=1000, K=1024, MB=1000*1000, M=1024*1024, GB=1000*1000*1000, G=1024*1024*1024 BYTES. example : 1M | 512kB',
        },
      ],
      when: "action=='disk-read-payload'",
    },
    {
      field: 'ref',
      label: 'disk-write-payload',
      children: [
        {
          field: 'text',
          label: 'path',
          value: '',
          helperText:
            'specifies the location to fill data in. if path not provided, payload will read/write from/into a temp file, temp file will be deleted after writing',
        },
        {
          field: 'number',
          label: 'payload-process-num',
          value: 0,
          helperText: 'specifies the number of process work on writing, default 1, only 1-255 is valid value',
        },
        {
          field: 'text',
          label: 'size',
          value: '',
          helperText:
            'specifies how many units of data will write into the file path. support unit: c=1, w=2, b=512, kB=1000, K=1024, MB=1000*1000, M=1024*1024, GB=1000*1000*1000, G=1024*1024*1024 BYTES. example : 1M | 512kB',
        },
      ],
      when: "action=='disk-write-payload'",
    },
    {
      field: 'ref',
      label: 'file-append',
      children: [
        {
          field: 'number',
          label: 'count',
          value: 0,
          helperText: 'Count is the number of times to append the data.',
        },
        {
          field: 'text',
          label: 'data',
          value: '',
          helperText: 'Data is the data for append.',
        },
        {
          field: 'text',
          label: 'file-name',
          value: '',
          helperText: 'FileName is the name of the file to be created, modified, deleted, renamed, or appended.',
        },
      ],
      when: "action=='file-append'",
    },
    {
      field: 'ref',
      label: 'file-create',
      children: [
        {
          field: 'text',
          label: 'dir-name',
          value: '',
          helperText: 'DirName is the directory name to create or delete.',
        },
        {
          field: 'text',
          label: 'file-name',
          value: '',
          helperText: 'FileName is the name of the file to be created, modified, deleted, renamed, or appended.',
        },
      ],
      when: "action=='file-create'",
    },
    {
      field: 'ref',
      label: 'file-delete',
      children: [
        {
          field: 'text',
          label: 'dir-name',
          value: '',
          helperText: 'DirName is the directory name to create or delete.',
        },
        {
          field: 'text',
          label: 'file-name',
          value: '',
          helperText: 'FileName is the name of the file to be created, modified, deleted, renamed, or appended.',
        },
      ],
      when: "action=='file-delete'",
    },
    {
      field: 'ref',
      label: 'file-modify',
      children: [
        {
          field: 'text',
          label: 'file-name',
          value: '',
          helperText: 'FileName is the name of the file to be created, modified, deleted, renamed, or appended.',
        },
        {
          field: 'number',
          label: 'privilege',
          value: 0,
          helperText: 'Privilege is the file privilege to be set.',
        },
      ],
      when: "action=='file-modify'",
    },
    {
      field: 'ref',
      label: 'file-rename',
      children: [
        {
          field: 'text',
          label: 'dest-file',
          value: '',
          helperText: 'DestFile is the name to be renamed.',
        },
        {
          field: 'text',
          label: 'source-file',
          value: '',
          helperText: 'SourceFile is the name need to be renamed.',
        },
      ],
      when: "action=='file-create'",
    },
    {
      field: 'ref',
      label: 'file-replace',
      children: [
        {
          field: 'text',
          label: 'dest-string',
          value: '',
          helperText: 'DestStr is the destination string of the file.',
        },
        {
          field: 'text',
          label: 'file-name',
          value: '',
          helperText: 'FileName is the name of the file to be created, modified, deleted, renamed, or appended.',
        },
        {
          field: 'number',
          label: 'line',
          value: 0,
          helperText: 'Line is the line number of the file to be replaced.',
        },
        {
          field: 'text',
          label: 'origin-string',
          value: '',
          helperText: 'OriginStr is the origin string of the file.',
        },
      ],
      when: "action=='file-replace'",
    },
    {
      field: 'ref',
      label: 'http-abort',
      children: [
        {
          field: 'text',
          label: 'code',
          value: '',
          helperText: 'Code is a rule to select target by http status code in response',
        },
        {
          field: 'text',
          label: 'method',
          value: '',
          helperText: 'HTTP method',
        },
        {
          field: 'text',
          label: 'path',
          value: '',
          helperText: 'Match path of Uri with wildcard matches',
        },
        {
          field: 'number',
          label: 'port',
          value: 0,
          helperText: 'The TCP port that the target service listens on',
        },
        {
          field: 'numbers',
          label: 'proxy_ports',
          value: [],
          helperText:
            'Composed with one of the port of HTTP connection, we will only attack HTTP connection with port inside proxy_ports',
        },
        {
          field: 'text',
          label: 'target',
          value: '',
          helperText: 'HTTP target: Request or Response',
        },
      ],
      when: "action=='http-abort'",
    },
    {
      field: 'ref',
      label: 'http-config',
      children: [
        {
          field: 'text',
          label: 'file_path',
          value: '',
          helperText: 'The config file path',
        },
      ],
      when: "action=='http-config'",
    },
    {
      field: 'ref',
      label: 'http-delay',
      children: [
        {
          field: 'text',
          label: 'code',
          value: '',
          helperText: 'Code is a rule to select target by http status code in response',
        },
        {
          field: 'text',
          label: 'delay',
          value: '',
          helperText: 'Delay represents the delay of the target request/response',
        },
        {
          field: 'text',
          label: 'method',
          value: '',
          helperText: 'HTTP method',
        },
        {
          field: 'text',
          label: 'path',
          value: '',
          helperText: 'Match path of Uri with wildcard matches',
        },
        {
          field: 'number',
          label: 'port',
          value: 0,
          helperText: 'The TCP port that the target service listens on',
        },
        {
          field: 'numbers',
          label: 'proxy_ports',
          value: [],
          helperText:
            'Composed with one of the port of HTTP connection, we will only attack HTTP connection with port inside proxy_ports',
        },
        {
          field: 'text',
          label: 'target',
          value: '',
          helperText: 'HTTP target: Request or Response',
        },
      ],
      when: "action=='http-delay'",
    },
    {
      field: 'ref',
      label: 'http-request',
      children: [
        {
          field: 'number',
          label: 'count',
          value: 0,
          helperText: 'The number of requests to send',
        },
        {
          field: 'select',
          label: 'enable-conn-pool',
          value: false,
          items: [true, false],
          helperText: 'Enable connection pool',
        },
        {
          field: 'text',
          label: 'url',
          value: '',
          helperText: 'Request to send"',
        },
      ],
      when: "action=='http-request'",
    },
    {
      field: 'ref',
      label: 'jvm-exception',
      children: [
        {
          field: 'text',
          label: 'class',
          value: '',
          helperText: 'Optional.  Java class',
        },
        {
          field: 'text',
          label: 'exception',
          value: '',
          helperText: 'the exception which needs to throw for action `exception`',
        },
        {
          field: 'text',
          label: 'method',
          value: '',
          helperText: 'Optional.  the method in Java class',
        },
        {
          field: 'number',
          label: 'pid',
          value: 0,
          helperText: 'the pid of Java process which needs to attach',
        },
        {
          field: 'number',
          label: 'port',
          value: 0,
          helperText: 'Optional.  the port of agent server, default 9277',
        },
      ],
      when: "action=='jvm-exception'",
    },
    {
      field: 'ref',
      label: 'jvm-gc',
      children: [
        {
          field: 'number',
          label: 'pid',
          value: 0,
          helperText: 'the pid of Java process which needs to attach',
        },
        {
          field: 'number',
          label: 'port',
          value: 0,
          helperText: 'Optional.  the port of agent server, default 9277',
        },
      ],
      when: "action=='jvm-gc'",
    },
    {
      field: 'ref',
      label: 'jvm-latency',
      children: [
        {
          field: 'text',
          label: 'class',
          value: '',
          helperText: 'Optional.  Java class',
        },
        {
          field: 'number',
          label: 'latency',
          value: 0,
          helperText: "the latency duration for action 'latency', unit ms",
        },
        {
          field: 'text',
          label: 'method',
          value: '',
          helperText: 'Optional.  the method in Java class',
        },
        {
          field: 'number',
          label: 'pid',
          value: 0,
          helperText: 'the pid of Java process which needs to attach',
        },
        {
          field: 'number',
          label: 'port',
          value: 0,
          helperText: 'Optional.  the port of agent server, default 9277',
        },
      ],
      when: "action=='jvm-latency'",
    },
    {
      field: 'ref',
      label: 'jvm-mysql',
      children: [
        {
          field: 'text',
          label: 'database',
          value: '',
          helperText: 'the match database default value is "", means match all database',
        },
        {
          field: 'text',
          label: 'exception',
          value: '',
          helperText:
            'The exception which needs to throw for action `exception` or the exception message needs to throw in action `mysql`',
        },
        {
          field: 'number',
          label: 'latency',
          value: 0,
          helperText: "The latency duration for action 'latency' or the latency duration in action `mysql`",
        },
        {
          field: 'text',
          label: 'mysqlConnectorVersion',
          value: '',
          helperText: 'the version of mysql-connector-java, only support 5.X.X(set to "5") and 8.X.X(set to "8") now',
        },
        {
          field: 'number',
          label: 'pid',
          value: 0,
          helperText: 'the pid of Java process which needs to attach',
        },
        {
          field: 'number',
          label: 'port',
          value: 0,
          helperText: 'Optional.  the port of agent server, default 9277',
        },
        {
          field: 'text',
          label: 'sqlType',
          value: '',
          helperText:
            "the match sql type default value is \"\", means match all SQL type. The value can be 'select', 'insert', 'update', 'delete', 'replace'.",
        },
        {
          field: 'text',
          label: 'table',
          value: '',
          helperText: 'the match table default value is "", means match all table',
        },
      ],
      when: "action=='jvm-mysql'",
    },
    {
      field: 'ref',
      label: 'jvm-return',
      children: [
        {
          field: 'text',
          label: 'class',
          value: '',
          helperText: 'Optional.  Java class',
        },
        {
          field: 'text',
          label: 'method',
          value: '',
          helperText: 'Optional.  the method in Java class',
        },
        {
          field: 'number',
          label: 'pid',
          value: 0,
          helperText: 'the pid of Java process which needs to attach',
        },
        {
          field: 'number',
          label: 'port',
          value: 0,
          helperText: 'Optional.  the port of agent server, default 9277',
        },
        {
          field: 'text',
          label: 'value',
          value: '',
          helperText: "the return value for action 'return'",
        },
      ],
      when: "action=='jvm-return'",
    },
    {
      field: 'ref',
      label: 'jvm-rule-data',
      children: [
        {
          field: 'number',
          label: 'pid',
          value: 0,
          helperText: 'the pid of Java process which needs to attach',
        },
        {
          field: 'number',
          label: 'port',
          value: 0,
          helperText: 'Optional.  the port of agent server, default 9277',
        },
        {
          field: 'text',
          label: 'rule-data',
          value: '',
          helperText: "RuleData used to save the rule file's data, will use it when recover",
        },
      ],
      when: "action=='jvm-rule-data'",
    },
    {
      field: 'ref',
      label: 'jvm-stress',
      children: [
        {
          field: 'number',
          label: 'cpu-count',
          value: 0,
          helperText: 'the CPU core number need to use, only set it when action is stress',
        },
        {
          field: 'text',
          label: 'mem-type',
          value: '',
          helperText:
            "the memory type need to locate, only set it when action is stress, the value can be 'stack' or 'heap'",
        },
        {
          field: 'number',
          label: 'pid',
          value: 0,
          helperText: 'the pid of Java process which needs to attach',
        },
        {
          field: 'number',
          label: 'port',
          value: 0,
          helperText: 'Optional.  the port of agent server, default 9277',
        },
      ],
      when: "action=='jvm-stress'",
    },
    {
      field: 'ref',
      label: 'kafka-fill',
      children: [
        {
          field: 'text',
          label: 'host',
          value: '',
          helperText: 'The host of kafka server',
        },
        {
          field: 'number',
          label: 'maxBytes',
          value: 0,
          helperText: 'The max bytes to fill',
        },
        {
          field: 'number',
          label: 'messageSize',
          value: 0,
          helperText: 'The size of each message',
        },
        {
          field: 'text',
          label: 'password',
          value: '',
          helperText: 'The password of kafka client',
        },
        {
          field: 'number',
          label: 'port',
          value: 0,
          helperText: 'The port of kafka server',
        },
        {
          field: 'text',
          label: 'reloadCommand',
          value: '',
          helperText: 'The command to reload kafka config',
        },
        {
          field: 'text',
          label: 'topic',
          value: '',
          helperText: 'The topic to attack',
        },
        {
          field: 'text',
          label: 'username',
          value: '',
          helperText: 'The username of kafka client',
        },
      ],
      when: "action=='kafka-fill'",
    },
    {
      field: 'ref',
      label: 'kafka-flood',
      children: [
        {
          field: 'text',
          label: 'host',
          value: '',
          helperText: 'The host of kafka server',
        },
        {
          field: 'number',
          label: 'messageSize',
          value: 0,
          helperText: 'The size of each message',
        },
        {
          field: 'text',
          label: 'password',
          value: '',
          helperText: 'The password of kafka client',
        },
        {
          field: 'number',
          label: 'port',
          value: 0,
          helperText: 'The port of kafka server',
        },
        {
          field: 'number',
          label: 'threads',
          value: 0,
          helperText: 'The number of worker threads',
        },
        {
          field: 'text',
          label: 'topic',
          value: '',
          helperText: 'The topic to attack',
        },
        {
          field: 'text',
          label: 'username',
          value: '',
          helperText: 'The username of kafka client',
        },
      ],
      when: "action=='kafka-flood'",
    },
    {
      field: 'ref',
      label: 'kafka-io',
      children: [
        {
          field: 'text',
          label: 'configFile',
          value: '',
          helperText: 'The path of server config',
        },
        {
          field: 'select',
          label: 'nonReadable',
          value: false,
          items: [true, false],
          helperText: 'Make kafka cluster non-readable',
        },
        {
          field: 'select',
          label: 'nonWritable',
          value: false,
          items: [true, false],
          helperText: 'Make kafka cluster non-writable',
        },
        {
          field: 'text',
          label: 'topic',
          value: '',
          helperText: 'The topic to attack',
        },
      ],
      when: "action=='kafka-io'",
    },
    {
      field: 'ref',
      label: 'network-bandwidth',
      children: [
        {
          field: 'number',
          label: 'buffer',
          value: 0,
          helperText: '+kubebuilder:validation:Minimum=1',
        },
        {
          field: 'text',
          label: 'device',
          value: '',
          helperText: '',
        },
        {
          field: 'text',
          label: 'hostname',
          value: '',
          helperText: '',
        },
        {
          field: 'text',
          label: 'ip-address',
          value: '',
          helperText: '',
        },
        {
          field: 'number',
          label: 'limit',
          value: 0,
          helperText: '+kubebuilder:validation:Minimum=1',
        },
        {
          field: 'number',
          label: 'minburst',
          value: 0,
          helperText: '',
        },
        {
          field: 'number',
          label: 'peakrate',
          value: 0,
          helperText: '',
        },
        {
          field: 'text',
          label: 'rate',
          value: '',
          helperText: '',
        },
      ],
      when: "action=='network-bandwidth'",
    },
    {
      field: 'ref',
      label: 'network-corrupt',
      children: [
        {
          field: 'text',
          label: 'correlation',
          value: '',
          helperText: 'correlation is percentage (10 is 10%)',
        },
        {
          field: 'text',
          label: 'device',
          value: '',
          helperText: 'the network interface to impact',
        },
        {
          field: 'text',
          label: 'egress-port',
          value: '',
          helperText:
            "only impact egress traffic to these destination ports, use a ',' to separate or to indicate the range, such as 80, 8001:8010. it can only be used in conjunction with -p tcp or -p udp",
        },
        {
          field: 'text',
          label: 'hostname',
          value: '',
          helperText: 'only impact traffic to these hostnames',
        },
        {
          field: 'text',
          label: 'ip-address',
          value: '',
          helperText: 'only impact egress traffic to these IP addresses',
        },
        {
          field: 'text',
          label: 'ip-protocol',
          value: '',
          helperText: 'only impact traffic using this IP protocol, supported: tcp, udp, icmp, all',
        },
        {
          field: 'text',
          label: 'percent',
          value: '',
          helperText: 'percentage of packets to corrupt (10 is 10%)',
        },
        {
          field: 'text',
          label: 'source-port',
          value: '',
          helperText:
            "only impact egress traffic from these source ports, use a ',' to separate or to indicate the range, such as 80, 8001:8010. it can only be used in conjunction with -p tcp or -p udp",
        },
      ],
      when: "action=='network-corrupt'",
    },
    {
      field: 'ref',
      label: 'network-delay',
      children: [
        {
          field: 'text',
          label: 'accept-tcp-flags',
          value: '',
          helperText:
            'only the packet which match the tcp flag can be accepted, others will be dropped. only set when the IPProtocol is tcp, used for partition.',
        },
        {
          field: 'text',
          label: 'correlation',
          value: '',
          helperText: 'correlation is percentage (10 is 10%)',
        },
        {
          field: 'text',
          label: 'device',
          value: '',
          helperText: 'the network interface to impact',
        },
        {
          field: 'text',
          label: 'egress-port',
          value: '',
          helperText:
            "only impact egress traffic to these destination ports, use a ',' to separate or to indicate the range, such as 80, 8001:8010. it can only be used in conjunction with -p tcp or -p udp",
        },
        {
          field: 'text',
          label: 'hostname',
          value: '',
          helperText: 'only impact traffic to these hostnames',
        },
        {
          field: 'text',
          label: 'ip-address',
          value: '',
          helperText: 'only impact egress traffic to these IP addresses',
        },
        {
          field: 'text',
          label: 'ip-protocol',
          value: '',
          helperText: 'only impact traffic using this IP protocol, supported: tcp, udp, icmp, all',
        },
        {
          field: 'text',
          label: 'jitter',
          value: '',
          helperText: 'jitter time, time units: ns, us (or \u00B5s), ms, s, m, h.',
        },
        {
          field: 'text',
          label: 'latency',
          value: '',
          helperText: 'delay egress time, time units: ns, us (or \u00B5s), ms, s, m, h.',
        },
        {
          field: 'text',
          label: 'source-port',
          value: '',
          helperText:
            "only impact egress traffic from these source ports, use a ',' to separate or to indicate the range, such as 80, 8001:8010. it can only be used in conjunction with -p tcp or -p udp",
        },
      ],
      when: "action=='network-delay'",
    },
    {
      field: 'ref',
      label: 'network-dns',
      children: [
        {
          field: 'text',
          label: 'dns-domain-name',
          value: '',
          helperText: 'map this host to specified IP',
        },
        {
          field: 'text',
          label: 'dns-ip',
          value: '',
          helperText: 'map specified host to this IP address',
        },
        {
          field: 'text',
          label: 'dns-server',
          value: '',
          helperText: 'update the DNS server in /etc/resolv.conf with this value',
        },
      ],
      when: "action=='network-dns'",
    },
    {
      field: 'ref',
      label: 'network-down',
      children: [
        {
          field: 'text',
          label: 'device',
          value: '',
          helperText: 'The network interface to impact',
        },
        {
          field: 'text',
          label: 'duration',
          value: '',
          helperText: 'NIC down time, time units: ns, us (or \u00B5s), ms, s, m, h.',
        },
      ],
      when: "action=='network-down'",
    },
    {
      field: 'ref',
      label: 'network-duplicate',
      children: [
        {
          field: 'text',
          label: 'correlation',
          value: '',
          helperText: 'correlation is percentage (10 is 10%)',
        },
        {
          field: 'text',
          label: 'device',
          value: '',
          helperText: 'the network interface to impact',
        },
        {
          field: 'text',
          label: 'egress-port',
          value: '',
          helperText:
            "only impact egress traffic to these destination ports, use a ',' to separate or to indicate the range, such as 80, 8001:8010. it can only be used in conjunction with -p tcp or -p udp",
        },
        {
          field: 'text',
          label: 'hostname',
          value: '',
          helperText: 'only impact traffic to these hostnames',
        },
        {
          field: 'text',
          label: 'ip-address',
          value: '',
          helperText: 'only impact egress traffic to these IP addresses',
        },
        {
          field: 'text',
          label: 'ip-protocol',
          value: '',
          helperText: 'only impact traffic using this IP protocol, supported: tcp, udp, icmp, all',
        },
        {
          field: 'text',
          label: 'percent',
          value: '',
          helperText: 'percentage of packets to duplicate (10 is 10%)',
        },
        {
          field: 'text',
          label: 'source-port',
          value: '',
          helperText:
            "only impact egress traffic from these source ports, use a ',' to separate or to indicate the range, such as 80, 8001:8010. it can only be used in conjunction with -p tcp or -p udp",
        },
      ],
      when: "action=='network-duplicate'",
    },
    {
      field: 'ref',
      label: 'network-flood',
      children: [
        {
          field: 'text',
          label: 'duration',
          value: '',
          helperText: 'The number of seconds to run the iperf test',
        },
        {
          field: 'text',
          label: 'ip-address',
          value: '',
          helperText: 'Generate traffic to this IP address',
        },
        {
          field: 'number',
          label: 'parallel',
          value: 0,
          helperText: 'The number of iperf parallel client threads to run',
        },
        {
          field: 'text',
          label: 'port',
          value: '',
          helperText: 'Generate traffic to this port on the IP address',
        },
        {
          field: 'text',
          label: 'rate',
          value: '',
          helperText:
            'The speed of network traffic, allows bps, kbps, mbps, gbps, tbps unit. bps means bytes per second',
        },
      ],
      when: "action=='network-flood'",
    },
    {
      field: 'ref',
      label: 'network-loss',
      children: [
        {
          field: 'text',
          label: 'correlation',
          value: '',
          helperText: 'correlation is percentage (10 is 10%)',
        },
        {
          field: 'text',
          label: 'device',
          value: '',
          helperText: 'the network interface to impact',
        },
        {
          field: 'text',
          label: 'egress-port',
          value: '',
          helperText:
            "only impact egress traffic to these destination ports, use a ',' to separate or to indicate the range, such as 80, 8001:8010. it can only be used in conjunction with -p tcp or -p udp",
        },
        {
          field: 'text',
          label: 'hostname',
          value: '',
          helperText: 'only impact traffic to these hostnames',
        },
        {
          field: 'text',
          label: 'ip-address',
          value: '',
          helperText: 'only impact egress traffic to these IP addresses',
        },
        {
          field: 'text',
          label: 'ip-protocol',
          value: '',
          helperText: 'only impact traffic using this IP protocol, supported: tcp, udp, icmp, all',
        },
        {
          field: 'text',
          label: 'percent',
          value: '',
          helperText: 'percentage of packets to loss (10 is 10%)',
        },
        {
          field: 'text',
          label: 'source-port',
          value: '',
          helperText:
            "only impact egress traffic from these source ports, use a ',' to separate or to indicate the range, such as 80, 8001:8010. it can only be used in conjunction with -p tcp or -p udp",
        },
      ],
      when: "action=='network-loss'",
    },
    {
      field: 'ref',
      label: 'network-partition',
      children: [
        {
          field: 'text',
          label: 'accept-tcp-flags',
          value: '',
          helperText:
            'only the packet which match the tcp flag can be accepted, others will be dropped. only set when the IPProtocol is tcp, used for partition.',
        },
        {
          field: 'text',
          label: 'device',
          value: '',
          helperText: 'the network interface to impact',
        },
        {
          field: 'text',
          label: 'direction',
          value: '',
          helperText:
            "specifies the partition direction, values can be 'from', 'to'. 'from' means packets coming from the 'IPAddress' or 'Hostname' and going to your server, 'to' means packets originating from your server and going to the 'IPAddress' or 'Hostname'.",
        },
        {
          field: 'text',
          label: 'hostname',
          value: '',
          helperText: 'only impact traffic to these hostnames',
        },
        {
          field: 'text',
          label: 'ip-address',
          value: '',
          helperText: 'only impact egress traffic to these IP addresses',
        },
        {
          field: 'text',
          label: 'ip-protocol',
          value: '',
          helperText: 'only impact egress traffic to these IP addresses',
        },
      ],
      when: "action=='network-partition'",
    },
    {
      field: 'ref',
      label: 'process',
      children: [
        {
          field: 'text',
          label: 'process',
          value: '',
          helperText: 'the process name or the process ID',
        },
        {
          field: 'text',
          label: 'recoverCmd',
          value: '',
          helperText: 'the command to be run when recovering experiment',
        },
        {
          field: 'number',
          label: 'signal',
          value: 0,
          helperText: 'the signal number to send',
        },
      ],
      when: "action=='process'",
    },
    {
      field: 'ref',
      label: 'redis-cacheLimit',
      children: [
        {
          field: 'text',
          label: 'addr',
          value: '',
          helperText: 'The adress of Redis server',
        },
        {
          field: 'text',
          label: 'cacheSize',
          value: '',
          helperText: 'The size of `maxmemory`',
        },
        {
          field: 'text',
          label: 'password',
          value: '',
          helperText: 'The password of Redis server',
        },
        {
          field: 'text',
          label: 'percent',
          value: '',
          helperText: 'Specifies maxmemory as a percentage of the original value',
        },
      ],
      when: "action=='redis-cacheLimit'",
    },
    {
      field: 'ref',
      label: 'redis-expiration',
      children: [
        {
          field: 'text',
          label: 'addr',
          value: '',
          helperText: 'The adress of Redis server',
        },
        {
          field: 'text',
          label: 'expiration',
          value: '',
          helperText: 'The expiration of the keys',
        },
        {
          field: 'text',
          label: 'key',
          value: '',
          helperText: 'The keys to be expired',
        },
        {
          field: 'text',
          label: 'option',
          value: '',
          helperText: 'Additional options for `expiration`',
        },
        {
          field: 'text',
          label: 'password',
          value: '',
          helperText: 'The password of Redis server',
        },
      ],
      when: "action=='redis-expiration'",
    },
    {
      field: 'ref',
      label: 'redis-penetration',
      children: [
        {
          field: 'text',
          label: 'addr',
          value: '',
          helperText: 'The adress of Redis server',
        },
        {
          field: 'text',
          label: 'password',
          value: '',
          helperText: 'The password of Redis server',
        },
        {
          field: 'number',
          label: 'requestNum',
          value: 0,
          helperText: 'The number of requests to be sent',
        },
      ],
      when: "action=='redis-penetration'",
    },
    {
      field: 'ref',
      label: 'redis-restart',
      children: [
        {
          field: 'text',
          label: 'addr',
          value: '',
          helperText: 'The adress of Redis server',
        },
        {
          field: 'text',
          label: 'conf',
          value: '',
          helperText: 'The path of Sentinel conf',
        },
        {
          field: 'select',
          label: 'flushConfig',
          value: false,
          items: [true, false],
          helperText: 'The control flag determines whether to flush config',
        },
        {
          field: 'text',
          label: 'password',
          value: '',
          helperText: 'The password of Redis server',
        },
        {
          field: 'select',
          label: 'redisPath',
          value: false,
          items: [true, false],
          helperText: 'The path of `redis-server` command-line tool',
        },
      ],
      when: "action=='redis-restart'",
    },
    {
      field: 'ref',
      label: 'redis-stop',
      children: [
        {
          field: 'text',
          label: 'addr',
          value: '',
          helperText: 'The adress of Redis server',
        },
        {
          field: 'text',
          label: 'conf',
          value: '',
          helperText: 'The path of Sentinel conf',
        },
        {
          field: 'select',
          label: 'flushConfig',
          value: false,
          items: [true, false],
          helperText: 'The control flag determines whether to flush config',
        },
        {
          field: 'text',
          label: 'password',
          value: '',
          helperText: 'The password of Redis server',
        },
        {
          field: 'select',
          label: 'redisPath',
          value: false,
          items: [true, false],
          helperText: 'The path of `redis-server` command-line tool',
        },
      ],
      when: "action=='redis-stop'",
    },
    {
      field: 'ref',
      label: 'stress-cpu',
      children: [
        {
          field: 'number',
          label: 'load',
          value: 0,
          helperText:
            'specifies P percent loading per CPU worker. 0 is effectively a sleep (no load) and 100 is full loading.',
        },
        {
          field: 'label',
          label: 'options',
          value: [],
          helperText: 'extend stress-ng options',
        },
        {
          field: 'number',
          label: 'workers',
          value: 0,
          helperText: 'specifies N workers to apply the stressor.',
        },
      ],
      when: "action=='stress-cpu'",
    },
    {
      field: 'ref',
      label: 'stress-mem',
      children: [
        {
          field: 'label',
          label: 'options',
          value: [],
          helperText: 'extend stress-ng options',
        },
        {
          field: 'text',
          label: 'size',
          value: '',
          helperText:
            'specifies N bytes consumed per vm worker, default is the total available memory. One can specify the size as % of total available memory or in units of B, KB/KiB, MB/MiB, GB/GiB, TB/TiB..',
        },
      ],
      when: "action=='stress-mem'",
    },
    {
      field: 'ref',
      label: 'user_defined',
      children: [
        {
          field: 'text',
          label: 'attackCmd',
          value: '',
          helperText: 'The command to be executed when attack',
        },
        {
          field: 'text',
          label: 'recoverCmd',
          value: '',
          helperText: 'The command to be executed when recover',
        },
      ],
      when: "action=='user_defined'",
    },
    {
      field: 'ref',
      label: 'vm',
      children: [
        {
          field: 'text',
          label: 'vm-name',
          value: '',
          helperText: 'The name of the VM to be injected',
        },
      ],
      when: "action=='vm'",
    },
  ]
